ExtendSelector (Apache Ant API)
Description: declaration: package: org.apache.tools.ant.types.selectors, class: ExtendSelector

# Class ExtendSelector

java.lang.Object
org.apache.tools.ant.ProjectComponent
org.apache.tools.ant.types.DataType
org.apache.tools.ant.types.selectors.BaseSelector
org.apache.tools.ant.types.selectors.ExtendSelector

All Implemented Interfaces:
  `Cloneable, ResourceSelector, FileSelector`

public class ExtendSelector extends BaseSelector
Selector that selects files by forwarding the request on to other classes.

Since:
  1.5

- ## Field Summary

  ### Fields inherited from class DataType

  `checked, ref`
  Modifier and Type
  Field
  Description
  `protected boolean`
  `checked`
  Deprecated.
  since 1.7.
  `protected Reference`
  `ref`
  Deprecated.
  since 1.7.

  ### Fields inherited from class ProjectComponent

  `description, location, project`
  Modifier and Type
  Field
  Description
  `protected String`
  `description`
  Deprecated.
  since 1.6.x.
  `protected Location`
  `location`
  Deprecated.
  since 1.6.x.
  `protected Project`
  `project`
  Deprecated.
  since 1.6.x.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ExtendSelector()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addParam(Parameter p)`
  Create new parameters to pass to custom selector.
  `final Path`
  `createClasspath()`
  Specify the classpath to use to load the Selector (nested element).
  `final Path`
  `getClasspath()`
  Get the classpath
  `boolean`
  `isSelected(File basedir, String filename, File file)`
  Allows the custom selector to choose whether to select a file.
  `void`
  `selectorCreate()`
  Instantiates the identified custom selector class.
  `void`
  `setClassname(String classname)`
  Sets the classname of the custom selector.
  `final void`
  `setClasspath(Path classpath)`
  Set the classpath to load the classname specified using an attribute.
  `void`
  `setClasspathref(Reference r)`
  Set the classpath to use for loading a custom selector by using a reference.
  `void`
  `verifySettings()`
  These are errors specific to ExtendSelector only.

  ### Methods inherited from class BaseSelector

  `getError, setError, setError, validate`
  Modifier and Type
  Method
  Description
  `String`
  `getError()`
  Returns any error messages that have been set.
  `void`
  `setError(String msg)`
  Allows all selectors to indicate a setup error.
  `void`
  `setError(String msg, Throwable cause)`
  Allows all selectors to indicate a setup error.
  `void`
  `validate()`
  Subclasses can use this to throw the requisite exception in isSelected() in the case of an error condition.

  ### Methods inherited from class DataType

  `checkAttributesAllowed, checkChildrenAllowed, circularReference, clone, dieOnCircularReference, dieOnCircularReference, dieOnCircularReference, getCheckedRef, getCheckedRef, getCheckedRef, getCheckedRef, getCheckedRef, getDataTypeName, getRefid, invokeCircularReferenceCheck, isChecked, isReference, noChildrenAllowed, pushAndInvokeCircularReferenceCheck, setChecked, setRefid, tooManyAttributes, toString`
  Modifier and Type
  Method
  Description
  `protected void`
  `checkAttributesAllowed()`
  check that it is ok to set attributes, i.e that no reference is defined
  `protected void`
  `checkChildrenAllowed()`
  check that it is ok to add children, i.e that no reference is defined
  `protected BuildException`
  `circularReference()`
  Creates an exception that indicates the user has generated a loop of data types referencing each other.
  `Object`
  `clone()`
  `protected void`
  `dieOnCircularReference()`
  Convenience method.
  `protected void`
  `dieOnCircularReference(Stack<Object> stack, Project project)`
  Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).
  `protected void`
  `dieOnCircularReference(Project p)`
  Convenience method.
  `protected <T> T`
  `getCheckedRef()`
  Deprecated.
  use getCheckedRef(Class)
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass, String dataTypeName)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass, String dataTypeName, Project project)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Project p)`
  Deprecated.
  use getCheckedRef(Class)
  `protected String`
  `getDataTypeName()`
  Gets as descriptive as possible a name used for this datatype instance.
  `Reference`
  `getRefid()`
  get the reference set on this object
  `static void`
  `invokeCircularReferenceCheck(DataType dt, Stack<Object> stk, Project p)`
  Allow DataTypes outside org.apache.tools.ant.types to indirectly call dieOnCircularReference on nested DataTypes.
  `protected boolean`
  `isChecked()`
  The flag that is used to indicate that circular references have been checked.
  `boolean`
  `isReference()`
  Has the refid attribute of this element been set?
  `protected BuildException`
  `noChildrenAllowed()`
  Creates an exception that indicates that this XML element must not have child elements if the refid attribute is set.
  `static void`
  `pushAndInvokeCircularReferenceCheck(DataType dt, Stack<Object> stk, Project p)`
  Allow DataTypes outside org.apache.tools.ant.types to indirectly call dieOnCircularReference on nested DataTypes.
  `protected void`
  `setChecked(boolean checked)`
  Set the flag that is used to indicate that circular references have been checked.
  `void`
  `setRefid(Reference ref)`
  Set the value of the refid attribute.
  `protected BuildException`
  `tooManyAttributes()`
  Creates an exception that indicates that refid has to be the only attribute if it is set.
  `String`
  `toString()`
  Basic DataType toString().

  ### Methods inherited from class ProjectComponent

  `getDescription, getLocation, getProject, log, log, setDescription, setLocation, setProject`
  Modifier and Type
  Method
  Description
  `String`
  `getDescription()`
  Returns the description of the current action.
  `Location`
  `getLocation()`
  Returns the file/location where this task was defined.
  `Project`
  `getProject()`
  Returns the project to which this component belongs.
  `void`
  `log(String msg)`
  Logs a message with the default (INFO) priority.
  `void`
  `log(String msg, int msgLevel)`
  Logs a message with the given priority.
  `void`
  `setDescription(String desc)`
  Sets a description of the current action.
  `void`
  `setLocation(Location location)`
  Sets the file/location where this task was defined.
  `void`
  `setProject(Project project)`
  Sets the project object of this component.

  ### Methods inherited from class Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface FileSelector

  `isSelected`
  Modifier and Type
  Method
  Description
  `default boolean`
  `isSelected(Resource r)`
  Implement a basic `Resource` selection that delegates to this `FileSelector`.

- ## Constructor Details

  - ### ExtendSelector

    public ExtendSelector()

- ## Method Details

  - ### setClassname

    public void setClassname(String classname)
    Sets the classname of the custom selector.
    Parameters:
      `classname` - is the class which implements this selector

  - ### selectorCreate

    public void selectorCreate()
    Instantiates the identified custom selector class.

  - ### addParam

    public void addParam(Parameter p)
    Create new parameters to pass to custom selector.
    Parameters:
      `p` - The new Parameter object

  - ### setClasspath

    public final void setClasspath(Path classpath)
    Set the classpath to load the classname specified using an attribute.
    Parameters:
      `classpath` - the classpath to use

  - ### createClasspath

    public final Path createClasspath()
    Specify the classpath to use to load the Selector (nested element).
    Returns:
      a classpath to be configured

  - ### getClasspath

    public final Path getClasspath()
    Get the classpath
    Returns:
      the classpath

  - ### setClasspathref

    public void setClasspathref(Reference r)
    Set the classpath to use for loading a custom selector by using a reference.
    Parameters:
      `r` - a reference to the classpath

  - ### verifySettings

    public void verifySettings()
    These are errors specific to ExtendSelector only. If there are errors in the custom selector, it should throw a BuildException when isSelected() is called.
    Overrides:
      `verifySettings` in class `BaseSelector`

  - ### isSelected

    public boolean isSelected(File basedir, String filename, File file) throws BuildException
    Allows the custom selector to choose whether to select a file. This is also where the Parameters are passed to the custom selector, since we know we must have them all by now. And since we must know both classpath and classname, creating the class is deferred to here as well.
    Specified by:
      `isSelected` in interface `FileSelector`
    Specified by:
      `isSelected` in class `BaseSelector`
    Parameters:
      `basedir` - The the base directory.
      `filename` - The name of the file to check.
      `file` - A File object for this filename.
    Returns:
      whether the file should be selected or not.
    Throws:
      `BuildException` - if an error occurs.